package org.xtext.test.car.resource;

import java.util.Collection;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtext.naming.IQualifiedNameProvider;
import org.eclipse.xtext.naming.QualifiedName;
import org.eclipse.xtext.parser.IEncodingProvider;
import org.eclipse.xtext.resource.IResourceDescription;
import org.eclipse.xtext.resource.IResourceDescription.Delta;
import org.eclipse.xtext.resource.IResourceDescription.Manager;
import org.eclipse.xtext.resource.IResourceDescriptions;
import org.eclipse.xtext.resource.IResourceServiceProvider;
import org.eclipse.xtext.resource.impl.DefaultResourceDescription;
import org.eclipse.xtext.resource.impl.DefaultResourceDescriptionDelta;
import org.eclipse.xtext.resource.impl.DefaultResourceDescriptionStrategy;
import org.eclipse.xtext.resource.impl.SimpleResourceDescriptionsBasedContainerManager;
import org.eclipse.xtext.util.CancelIndicator;
import org.eclipse.xtext.validation.CheckMode;
import org.eclipse.xtext.validation.IResourceValidator;
import org.eclipse.xtext.validation.Issue;
import org.xtext.test.car.Car;

public class CarResourceServiceProvider implements IResourceServiceProvider {

	final org.eclipse.xtext.resource.IContainer.Manager containerManager = new SimpleResourceDescriptionsBasedContainerManager();

	@Override
	public boolean canHandle(URI uri) {
		return uri.fileExtension().equals("cars");
	}

	@Override
	public <T> T get(Class<T> t) {
		try {
			return t.newInstance();
		} catch (Throwable e) {
			e.printStackTrace();
		}
		return null;
	}

	@Override
	public IResourceValidator getResourceValidator() {
		return new IResourceValidator() {
			@Override
			public List<Issue> validate(Resource resource, CheckMode mode, CancelIndicator indicator) {
				return Collections.emptyList();
			}
		};
	}

	@Override
	public org.eclipse.xtext.resource.IContainer.Manager getContainerManager() {
		return containerManager;
	}

	@Override
	public IEncodingProvider getEncodingProvider() {
		throw new UnsupportedOperationException();
	}

	@Override
	public Manager getResourceDescriptionManager() {
		return new Manager() {

			@Override
			public boolean isAffected(Collection<Delta> deltas, IResourceDescription candidate,
					IResourceDescriptions context) throws IllegalArgumentException {
				return false;
			}

			@Override
			public boolean isAffected(Delta delta, IResourceDescription candidate) throws IllegalArgumentException {
				return false;
			}

			@Override
			public Delta createDelta(IResourceDescription oldDescription, IResourceDescription newDescription) {
				return new DefaultResourceDescriptionDelta(oldDescription, newDescription);
			}

			@Override
			public IResourceDescription getResourceDescription(Resource resource) {
				DefaultResourceDescriptionStrategy strat = new DefaultResourceDescriptionStrategy();
				strat.setQualifiedNameProvider(new IQualifiedNameProvider.AbstractImpl() {

					@Override
					public QualifiedName getFullyQualifiedName(EObject obj) {
						return QualifiedName.create(((Car) obj).getName());
					}
				});

				return new DefaultResourceDescription(resource, strat);
			}
		};
	}
}
